-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------

function DummyTwins:StartActivity()
   	print("START! -- DummyAssault:StartActivity()!");
	
	self.AirAmbush1 = SceneMan.Scene:GetArea("AirAmbush1");
	self.AirAmbush1LZ = SceneMan.Scene:GetArea("AirAmbush1LZ");

	self.AirAmbush2 = SceneMan.Scene:GetArea("AirAmbush2");
	self.AirAmbush2LZ = SceneMan.Scene:GetArea("AirAmbush2LZ");

	self.TowerAlertYellow = SceneMan.Scene:GetArea("TowerAlertYellow");
	self.TowerAlertRed = SceneMan.Scene:GetArea("TowerAlertRed");

	self.GlobalBombard = SceneMan.Scene:GetArea("GlobalBombard");
	self.HeavyBombard = SceneMan.Scene:GetArea("HeavyBombard");

	self.BaseAlertLZ = SceneMan.Scene:GetArea("BaseAlertLZ");
	self.GlobalAssaultLZ = SceneMan.Scene:GetArea("GlobalAssaultLZ");
	self.SweepZone = SceneMan.Scene:GetArea("SweepZone");
	
	self.braindead = {};
	self.CPUBrain1 = nil;
	self.CPUBrain2 = nil;
	self.VictimBrain = nil;
	self.LightWList = { "Blaster", "Nailgun", "Scouting Rifle", "Frag Nailer"};
	self.HeavyWList = { "Repeater", "Destroyer Cannon", "Nailer Cannon" };
	self.SuperHeavyWList = { "Impulse Cannon", "Repeater", "Annihiliator"};
	self.BList = { "Impulse Grenade" };
	self.MOIDLimit = 220;
    
    self.AirAmbush1Triggered = false;
    self.AirAmbush2Triggered = false;
  	self.AlertYellowTriggered = false;
  	self.AlertRedTriggered = false;
  	self.CPUBrain1AmbushTriggered = false;
  	self.CPUBrain2AmbushTriggered = false;
  	self.CPUBrainsDeadTriggered = false;
    
    self.AmbushType = { NOAMBUSH = 0, AIR1 = 1, AIR2 = 2 , YELLOW  = 3 , RED = 4 , GLOBAL = 5};
    self.FightStage = { NOFIGHT = 0, TOWERASSAULT = 1, BASEALERT = 2, SWEEP = 3, SWEEPDONE = 4, BOMBARD = 5, DUMMYGLOBALCOUNTER = 6};
    self.CurrentFightStage = self.FightStage.NOFIGHT;
    
    self.GenericTimer = Timer();
    self.GenericTimer:Reset();

   	self.SpawnTimer = Timer();
	self.SpawnTimer:Reset();

    -- Bombard attributes
    self.BombTimer = Timer();
    self.LastBomb = Timer();
	self.StartBombard = false;
	
		
	self.AirAmbush1SpawnedCount = 0;
	self.AirAmbush2SpawnedCount = 0;
	self.AlertYellowSpawnedCount = 0;
	self.AlertRedSpawnedCount = 0;
	self.AirAmbush1SpawnLimit = 1 + math.random(3);
	self.AirAmbush2SpawnLimit = 1 + math.random(3);
	self.AlertYellowSpawnLimit = 4 + math.random(4);
	self.AlertRedSpawnLimit = 2000;
	self.AirAmbushLastSpawn = Timer();
	self.DropshipSpawnInterval = 24000;
	self.BaseSpawnInterval = 26000;

	self.EnemyUnitLimit = 10;
	self.EnemyUnitCount = 0;
	
   	-- Set up teams
   	-- Team 2 is always CPU
   	self.PlayerTeam = Activity.TEAM_1;
   	self.CPUTeam = Activity.TEAM_2;
    
   	-- Set up players
    for player = 0, self.PlayerCount - 1 do
        -- Check if we already have a brain assigned
        if not self:GetPlayerBrain(player) then
			self.braindead[player] = false;
			local brain = CreateAHuman("Heavy Brain Robot", "DummyTwins.rte");
			self.VictimBrain = brain;
			brain.Pos = Vector(2842 , 800 - player * 36);
			brain:AddInventoryItem(CreateHDFirearm("Auto Pistol","Coalition.rte"));
			brain:AddInventoryItem(CreateHDFirearm("Assault Rifle","Coalition.rte"));
			brain.AIMode = Actor.AIMODE_SENTRY;
            -- Let the spawn into the world, passing ownership
            MovableMan:AddActor(brain);
            -- Set the found brain to be the selected actor at start
            self:SetPlayerBrain(brain, player);
            SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
            self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
            -- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
            self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
        end
    end

    -- Set up AI modes for the Actors that have been added to the scene by the scene definition
    for actor in MovableMan.AddedActors do
        if actor.Team == self.CPUTeam then
            actor.AIMode = Actor.AIMODE_SENTRY;
			
			-- Assign both CPU brains
			if actor.PresetName == "Dummy Controller" then
				if self.CPUBrain1 == nil then
					self.CPUBrain1 = actor;
				else
					self.CPUBrain2 = actor;
				end
			end
        end
    end

    -- Set the team's funds
    self:SetTeamFunds(self:GetStartingGold(),Activity.TEAM_1);
	
	if self:GetFogOfWarEnabled() then
		SceneMan:MakeAllUnseen(Vector(96, 96), Activity.TEAM_1)
	end

    --------------------------
    self.SpawnTimer:Reset();
    
end

-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------

function DummyTwins:PauseActivity(pause)
    print("PAUSE! -- DummyAssault:PauseActivity()!");
end

-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------

function DummyTwins:EndActivity()
    print("END! -- DummyAssault:EndActivity()!");
end

-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------

function DummyTwins:UpdateActivity()
   	-- Clear all objective markers, they get re-added each frame
   	self:ClearObjectivePoints();

	-- Count enemy actors
	self.EnemyUnitCount = 0

	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam and (actor.ClassName == "AHuman" or actor.ClassName == "ACrab") then
			self.EnemyUnitCount = self.EnemyUnitCount + 1
		end
	end
	
	if not (self.ActivityState == Activity.OVER) then
		-- Iterate through all human players
		for player = 0, self.PlayerCount - 1 do
			-- The current player's team
			local team = self:GetTeamOfPlayer(player);
	
			-- Make sure the game is not already ending
			-- Check if any player's brain is dead
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player);
				-- Try to find a new unasigned brain this player can use instead, or if his old brain entered a craft
				local newBrain = MovableMan:GetUnassignedBrain(team);
				-- Found new brain actor, assign it and keep on truckin'
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);

					self.VictimBrain = newBrain;
				else
					FrameMan:SetScreenText("Your brain has been lost!", player, 333, -1, false);
					self.braindead[player] = true;
					
					-- Now see if all brains of self player's team are dead, and if so, end the game
					--if not MovableMan:GetClosestBrainActor(team) then
						self.WinnerTeam = self:OtherTeam(team);
						ActivityMan:EndActivity();
					--end
				end
			else
				-- Update the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
				self:SetObservationTarget(brain.Pos, player)
			end -- 
		end --for

	-- Game over, show the appropriate messages until a certain time
	elseif not self.GameOverTimer:IsPastSimMS(self.GameOverPeriod) then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
			-- TODO: make more appropriate messages here for run out of funds endings
			if team == self.WinnerTeam then
				FrameMan:SetScreenText("Congratulations, you've destroyed the dummy base!", player, 0, -1, false);
			else
				FrameMan:SetScreenText("Your brain has been lost!", player, 0, -1, false);
			end
		end
	end
	
	if self.CurrentFightStage == self.FightStage.NOFIGHT or self.CurrentFightStage == self.FightStage.TOWERASSAULT then
		-- Check if player triggered ambush on LZ1
		if self.AirAmbush1Triggered == false then
			for actor in MovableMan.Actors do
				if actor.Team == Activity.TEAM_1 and self.AirAmbush1:IsInside(actor.Pos) then
					self.AirAmbush1Triggered = true;
					self.AirAmbushLastSpawn:Reset();
					self.CurrentFightStage = self.FightStage.TOWERASSAULT;
					print("AIR1 Triggered");

					for player = 0, self.PlayerCount - 1 do
						self:ResetMessageTimer(player);
						FrameMan:ClearScreenText(player);
						-- FrameMan:SetScreenText("Try to capture live Dummies for additional money.", player, 1000, 5000, true);
						FrameMan:SetScreenText("CAPTURE LIVE DUMMIES FOR ADDITIONAL GOLD", player, 1000, 8000, true);
					end
				end
			end
		end
	
		-- Check if player triggered ambush on LZ2
		if self.AirAmbush2Triggered == false then
			for actor in MovableMan.Actors do
				if actor.Team == Activity.TEAM_1 and self.AirAmbush2:IsInside(actor.Pos) then
					self.AirAmbush2Triggered = true;
					self.AirAmbushLastSpawn:Reset();
					print("AIR2 Triggered");
				end
			end
		end

		-- Check if player triggered yellow alert on the entrance to the base
		if self.AlertYellowTriggered == false then
			for actor in MovableMan.Actors do
				if actor.Team == Activity.TEAM_1 and self.TowerAlertYellow:IsInside(actor.Pos) then
					self.AlertYellowTriggered = true;
					self.AirAmbushLastSpawn:Reset();
					self.CurrentFightStage = self.FightStage.BASEALERT;
					print("YELLOW Triggered");
				end
			end
		end
	
		-- Check if player triggered red alert on the controller's lair
		if self.AlertRedTriggered == false then
			for actor in MovableMan.Actors do
				if actor.Team == Activity.TEAM_1 and self.TowerAlertYellow:IsInside(actor.Pos) then
					self.AlertRedTriggered = true;
					self.AirAmbushLastSpawn:Reset();
					self.CurrentFightStage = self.FightStage.BASEALERT;
					
					-- Abort all other ambushes, defend base at all costs
					self.AirAmbush1SpawnedCount = self.AirAmbush1SpawnLimit;
					self.AirAmbush2SpawnedCount = self.AirAmbush2SpawnLimit;
					self.AlertYellowSpawnedCount = self.AlertYellowSpawnLimit;
					
					print("RED Triggered");
				end
			end
		end
	end
	
	-- Spawn ships on triggered air ambushes
	if self.AirAmbushLastSpawn:IsPastSimMS(self.DropshipSpawnInterval) and MovableMan:GetMOIDCount() <= self.MOIDLimit then
		-- Determine for which ambush we should spawn drop ship
		local ambushtype = self.AmbushType.NOAMBUSH;
		
		if self.AirAmbush1SpawnedCount < self.AirAmbush1SpawnLimit and self.AirAmbush1Triggered then
			ambushtype = self.AmbushType.AIR1;
			print("Selected AIR1");				
		elseif self.AirAmbush2SpawnedCount < self.AirAmbush2SpawnLimit and self.AirAmbush2Triggered then
			ambushtype = self.AmbushType.AIR2;
			print("Selected AIR2");				
		elseif self.AlertYellowSpawnedCount < self.AlertYellowSpawnLimit and self.AlertYellowTriggered then
			ambushtype = self.AmbushType.YELLOW;
			print("Selected YELLOW");				
		elseif self.AlertRedSpawnedCount < self.AlertRedSpawnLimit and self.AlertRedTriggered then
			ambushtype = self.AmbushType.RED;
			print("Selected RED");	
		elseif self.CurrentFightStage == self.FightStage.DUMMYGLOBALCOUNTER then
			ambushtype = self.AmbushType.GLOBAL;
			print("Selected GLOBAL");
		end

		if ambushtype ~= self.AmbushType.NOAMBUSH then
			-- Add dummies and ship
			--print("Spawn ship");	
			if MovableMan:GetMOIDCount() < self.MOIDLimit and self.EnemyUnitCount < self.EnemyUnitLimit then
				local ship = CreateACDropShip("Drop Ship","Dummy.rte");
				for i = 0 , 1 do
					--print("Spawn dummies");				
					local actor = CreateAHuman("Dummy");
					actor.Team = Activity.TEAM_2;

					if ambushtype == self.AmbushType.AIR1 then 
						actor.AIMode = Actor.AIMODE_BRAINHUNT;
						actor:AddInventoryItem(CreateTDExplosive(self.BList[math.random(#self.BList)],"Dummy.rte"));
						actor:AddInventoryItem(CreateHDFirearm(self.LightWList[math.random(#self.LightWList)],"Dummy.rte"));
					elseif ambushtype == self.AmbushType.AIR2 then 
						actor.AIMode = Actor.AIMODE_BRAINHUNT;
						actor:AddInventoryItem(CreateTDExplosive(self.BList[math.random(#self.BList)],"Dummy.rte"));
						actor:AddInventoryItem(CreateHDFirearm(self.HeavyWList[math.random(#self.HeavyWList)],"Dummy.rte"));
					elseif ambushtype == self.AmbushType.YELLOW or ambushtype == self.AmbushType.RED then 
						if math.random() < 0.5 then
							if MovableMan:IsActor(self.CPUBrain1) then
								actor.AIMode = Actor.AIMODE_GOTO;
								actor:ClearAIWaypoints();
								actor:AddAIMOWaypoint(self.CPUBrain1);
							else
								actor.AIMode = Actor.AIMODE_BRAINHUNT;
							end
						else
							if MovableMan:IsActor(self.CPUBrain2) then
								actor.AIMode = Actor.AIMODE_GOTO;
								actor:ClearAIWaypoints();
								actor:AddAIMOWaypoint(self.CPUBrain2);
							else
								actor.AIMode = Actor.AIMODE_BRAINHUNT;
							end
						end

						if ambushtype == self.AmbushType.YELLOW then
							actor:AddInventoryItem(CreateHDFirearm(self.HeavyWList[math.random(#self.HeavyWList)],"Dummy.rte"));
						else
							actor:AddInventoryItem(CreateHDFirearm(self.SuperHeavyWList[math.random(#self.SuperHeavyWList)],"Dummy.rte"));
						end
					elseif ambushtype == self.AmbushType.GLOBAL then
						actor:AddInventoryItem(CreateHDFirearm(self.SuperHeavyWList[math.random(#self.SuperHeavyWList)],"Dummy.rte"));
						actor.AIMode = Actor.AIMODE_BRAINHUNT;
					end

					ship:AddInventoryItem(actor);
				end
			
				if ambushtype == self.AmbushType.AIR1 then 
					ship.Pos = Vector(self.AirAmbush1LZ:GetRandomPoint().X, 0);
					self.AirAmbush1SpawnedCount = self.AirAmbush1SpawnedCount + 1;
				elseif ambushtype == self.AmbushType.AIR2 then 
					ship.Pos = Vector(self.AirAmbush2LZ:GetRandomPoint().X, 0);
					self.AirAmbush2SpawnedCount = self.AirAmbush2SpawnedCount + 1;
				elseif ambushtype == self.AmbushType.YELLOW then
					ship.Pos = Vector(self.BaseAlertLZ:GetRandomPoint().X, 0);
					self.AlertYellowSpawnedCount = self.AlertYellowSpawnedCount + 1;
				elseif ambushtype == self.AmbushType.RED then
					ship.Pos = Vector(self.BaseAlertLZ:GetRandomPoint().X, 0);
					-- On red alert ships spawn until both brains are destroyed
					-- self.AlertRedSpawnedCount = self.AlertRedSpawnedCount + 1;
				elseif ambushtype == self.AmbushType.GLOBAL then
					ship.Pos = Vector(self.GlobalAssaultLZ:GetRandomPoint().X, 0);
				end
				ship.Team = Activity.TEAM_2;
				ship:SetControllerMode(Controller.CIM_AI, -1);
				MovableMan:AddActor(ship);
				self.AirAmbushLastSpawn:Reset();
				print("Ambush spawn complete");
			end
		end
	end

	-- Spawn Dummies from outside of screen
	if self.CurrentFightStage == self.FightStage.BASEALERT then
		if self.SpawnTimer:IsPastSimMS(self.BaseSpawnInterval) then
			if MovableMan:GetMOIDCount() <= self.MOIDLimit and self.EnemyUnitCount < self.EnemyUnitLimit then
				local actor = nil;
				local rand1 = math.random();
				if rand1 > 0.03 then
					actor = CreateAHuman("Dummy");
					actor.Team = Activity.TEAM_2;
					actor:AddInventoryItem(CreateHDFirearm(self.LightWList[math.random(#self.LightWList)],"Dummy.rte"));
				else
					actor = CreateACrab("Dreadnought");
					actor.Team = Activity.TEAM_2;
				end

				actor.AIMode = Actor.AIMODE_BRAINHUNT;
				
				actor.Pos = Vector(10,828);
				MovableMan:AddActor(actor);
			end
			self.SpawnTimer:Reset();
		end
	end
	
	-- Commence sweep, and wait for surprises
	if self.CurrentFightStage == self.FightStage.SWEEP then
		if self.GenericTimer:IsPastSimMS(10000) and not self.GenericTimer:IsPastSimMS(10500) then
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				-- FrameMan:SetScreenText("There are still some dummies inside the building. Eliminate them.", player, 0, 9000, true);
				FrameMan:SetScreenText("ELIMINATE DUMMIES INSIDE THE BUILDING.", player, 0, 14000, true);
			end
		end

		local liveenemies = 0;
		for actor in MovableMan.Actors do
			if actor.Team == Activity.TEAM_2 and self.SweepZone:IsInside(actor.Pos) and (actor.ClassName == "AHuman" or actor.ClassName == "ACrab") then
				liveenemies = liveenemies + 1;
				
				if not self.GenericTimer:IsPastSimMS(14000) then
					self:AddObjectivePoint("Kill", actor.Pos + Vector(0 , -20), Activity.TEAM_1, GameActivity.ARROWDOWN);
				end
			end
		end
		
		if liveenemies < 3 then
			print("Sweep complete");
			self.GenericTimer:Reset();
			self.CurrentFightStage = self.FightStage.SWEEPDONE;

			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				-- FrameMan:SetScreenText("Dummies deployed heavy orbital bombing platforms to wipe out the whole area.", player, 0, 8000, true);
				FrameMan:SetScreenText("DUMMIES DEPLOYED HEAVY ORBITAL BOMBING PLATFORMS TO WIPE OUT THE WHOLE AREA", player, 0, 14000, true);
			end
		end
	end

	-- Sweep complete, comence bombardment sequence
	if self.CurrentFightStage == self.FightStage.SWEEPDONE then
		-- Show bombard warning
		if not self.GenericTimer:IsPastSimMS(30000) then
			self:AddObjectivePoint("SHELTER", Vector(50,808), Activity.TEAM_1, GameActivity.ARROWDOWN);
			self:AddObjectivePoint("SHELTER", Vector(200,808), Activity.TEAM_1, GameActivity.ARROWDOWN);
			self:AddObjectivePoint("SHELTER", Vector(350,808), Activity.TEAM_1, GameActivity.ARROWDOWN);
			self:AddObjectivePoint("SHELTER", Vector(500,808), Activity.TEAM_1, GameActivity.ARROWDOWN);
		end

		-- Show second part of the bombard warning
		if self.GenericTimer:IsPastSimMS(14500) and not self.GenericTimer:IsPastSimMS(15000) then
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				-- FrameMan:SetScreenText("Get your forces inside the building!!!", player, 0, 9000, true);
				FrameMan:SetScreenText("GET YOUR FORCES INSIDE THE BUILDING !!!", player, 0, 15000, true);
			end
		end

		-- Show last warning
		if self.GenericTimer:IsPastSimMS(45000) then
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				--FrameMan:SetScreenText("Dummy bombs approaching!", player, 1500, 7000, true);
				FrameMan:SetScreenText("BOMBS APPROACHING !!!", player, 1500, 9000, true);
			end
		end

		-- Comence bombardment
		if self.GenericTimer:IsPastSimMS(50000) then
			self.CurrentFightStage = self.FightStage.BOMBARD;
			self.StartBombard = true;
			self.BombTimer:Reset();
		end
	end

	-- Drop bombs make badaboom
	if self.StartBombard == true and self.CurrentFightStage == self.FightStage.BOMBARD then
		if not self.BombTimer:IsPastSimMS(25000) then
			if self.LastBomb:IsPastSimMS(20) then
				if math.random() < 0.35 and MovableMan:GetMOIDCount() <= self.MOIDLimit then
					local bombtype = "Standard Bomb";
					local bombpackage = "Base.rte"
					
					if math.random() <= 0.95 then
						bombtype = "Standard Bomb";
						bombpackage = "Coalition.rte"
					else
						bombtype = "Heavy Orbital Bomb";
						bombpackage = "DummyTwins.rte"
					end
	
					local bomb = CreateTDExplosive(bombtype, bombpackage);
					bomb.Pos = Vector(self.GlobalBombard:GetRandomPoint().X, 0)
					bomb.RotAngle = math.rad(270);
					bomb.Vel = Vector(0,25);
					MovableMan:AddItem(bomb);
				end;
				
				if math.random() < 0.055 then
					local bomb = CreateTDExplosive("Heavy Orbital Bomb","DummyTwins.rte");
					bomb.Pos = Vector(self.HeavyBombard:GetRandomPoint().X, 0)
					bomb.RotAngle = math.rad(270);
					MovableMan:AddItem(bomb);
				end;
				self.LastBomb:Reset();
			end;
		else
			--Start final assault, decrease dropship spawn interval
			self.StartBombard = false;
			self.CurrentFightStage = self.FightStage.DUMMYGLOBALCOUNTER;
			self.DropshipSpawnInterval = 15000;
			
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				-- FrameMan:SetScreenText("Dummies has launched massive counterstrike. Evacuate brain as soon as possible.", player, 1500, 15000, true);
				FrameMan:SetScreenText("DUMMIES HAS LAUNCHED MASSIVE COUNTERSTRIKE. EVACUATE BRAIN !!!", player, 1500, 15000, true);
			end
		end
	end

	-- Show evacuation mark as suggested by numgun
	if self.CurrentFightStage == self.FightStage.DUMMYGLOBALCOUNTER then
		self:AddObjectivePoint("EVACUATE", Vector(500, 1), Activity.TEAM_1, GameActivity.ARROWUP);
		self:AddObjectivePoint("EVACUATE", Vector(1500, 1), Activity.TEAM_1, GameActivity.ARROWUP);
		self:AddObjectivePoint("EVACUATE", Vector(2500, 1), Activity.TEAM_1, GameActivity.ARROWUP);
	end

	-- Mark the enemy brains
	if MovableMan:IsActor(self.CPUBrain1) then
	    self:AddObjectivePoint("Destroy!", self.CPUBrain1.AboveHUDPos+Vector(0,-16), Activity.TEAM_1, GameActivity.ARROWDOWN);
	else
		if self.CPUBrain1AmbushTriggered == false then
			self.CPUBrain1AmbushTriggered = true;
			if MovableMan:GetMOIDCount() <= self.MOIDLimit then
				local actor = CreateACrab("Dreadnought");
				actor.Team = Activity.TEAM_2;
				actor.AIMode = Actor.AIMODE_SENTRY;
				actor.Pos = Vector(8,232);
				MovableMan:AddActor(actor);
			end
		end
	end
	
	if MovableMan:IsActor(self.CPUBrain2) then
		self:AddObjectivePoint("Destroy!", self.CPUBrain2.AboveHUDPos+Vector(0,-16), Activity.TEAM_1, GameActivity.ARROWDOWN);
	else
		if self.CPUBrain2AmbushTriggered == false then
			self.CPUBrain2AmbushTriggered = true;
			if MovableMan:GetMOIDCount() <= self.MOIDLimit then
				local actor = CreateACrab("Dreadnought");
				actor.Team = Activity.TEAM_2;
				actor.AIMode = Actor.AIMODE_SENTRY;
				actor.Pos = Vector(8,378);
				MovableMan:AddActor(actor);
			end
		end
	end
	
	-- Check if we killed all brains
	if not self.CPUBrainsDeadTriggered then
		if not MovableMan:IsActor(self.CPUBrain1) and not MovableMan:IsActor(self.CPUBrain2) then
			--This objective is splitted in two parts.
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				-- FrameMan:SetScreenText("Well done. Both Dummy Controllers destroyed. Dummy assembler stopped.", player, 0, 9000, true);
				FrameMan:SetScreenText("BOTH CONTROLLERS DESTROYED. DUMMY ASSEMBLER STOPPED", player, 0, 12000, true);
			end
			self.CurrentFightStage = self.FightStage.SWEEP;
			self.GenericTimer:Reset();
			
			-- stop all assaults
			self.AirAmbush1SpawnedCount = self.AirAmbush1SpawnLimit;
			self.AirAmbush2SpawnedCount = self.AirAmbush2SpawnLimit;
			self.AlertYellowSpawnedCount = self.AlertYellowSpawnLimit;
			self.AlertRedSpawnedCount = self.AlertRedSpawnLimit;
			self.CPUBrainsDeadTriggered = true;
		end
	end
	
	self:YSortObjectivePoints();
end

function DummyTwins:CraftEnteredOrbit()
	--If a craft leaves with the brain robot...
	if self.OrbitedCraft:HasObject("Heavy Brain Robot") then
		if self.CurrentFightStage == self.FightStage.DUMMYGLOBALCOUNTER then
			-- Team 1 wins!
			self.WinnerTeam = Activity.TEAM_1;
			ActivityMan:EndActivity();
			-- Tell the script to stop running for brains as the game has ended.
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
			end
		else
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("Coward!!!", player, 1500, 10000, true);
			end
		end
	end

	if self.OrbitedCraft:HasObject("Dummy") and self.OrbitedCraft.Team == Activity.TEAM_1 then
		for player = 0, self.PlayerCount - 1 do
			self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
			-- FrameMan:SetScreenText("Live Dummies captured, 500 oz awarded.", player, 1000, 5000, true);
			FrameMan:SetScreenText("LIVE DUMMIES CAPTURED, 1000 OZ AWARDED", player, 1000, 7000, true);
		end
		self:SetTeamFunds( self:GetTeamFunds(Activity.TEAM_1) + 1000 , Activity.TEAM_1);
	end
end

